Index: main/waeup.sirp/branches/ulif-extimgstore/buildout.cfg
===================================================================
--- main/waeup.sirp/branches/ulif-extimgstore/buildout.cfg	(revision 7030)
+++ main/waeup.sirp/branches/ulif-extimgstore/buildout.cfg	(revision 7031)
@@ -54,5 +54,5 @@
 zope.xmlpickle = 3.4.0
 # Require latest version...
-Sphinx =
+Sphinx = 1.0.7
 ZODB3 = 3.10.3
 docutils = 0.7
Index: main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/resources.py
===================================================================
--- main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/resources.py	(revision 7030)
+++ main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/resources.py	(revision 7031)
@@ -38,10 +38,10 @@
 #:
 #: * In the `update()` method of the responsible view/page/form
-#:   require the JavaScript code to be rendered into the page:
+#:   require the JavaScript code to be rendered into the page::
 #:
 #:     from waeup.sirp.browser.resources import datepicker
-#:     ...
-#:     class MyPage(...):
-#:       ...
+#:     # ...
+#:     class MyPage(...):
+#:       # ...
 #:       def update(self):
 #:         datepicker.need()
@@ -51,5 +51,7 @@
 #:
 #: * In your HTML code add some ``<input>`` or ``<div>`` tag with
-#:   ``class`` set to ``datepicker``, like this::
+#:   ``class`` set to ``datepicker``, like this:
+#:
+#:   .. code-block:: html
 #:
 #:     <input type="text" name="entrydate" class="datepicker" />
@@ -85,5 +87,5 @@
 #: ``"datepicker-de-year"``
 #:    same but also adds a select field for year
-#: 
+#:
 #: ``"datepicker-us"``
 #:    renders date in format ``MM/DD/YYYY`` (U.S. format)
@@ -97,11 +99,12 @@
 #: If you want generate alert or confirm messages then you have to perform
 #: two steps:
-#: * In the `update()` method of the responsible view/page/form
-#:   require the JavaScript code to be rendered into the page:
+#:
+#: * In the `update()` method of the responsible view/page/form
+#:   require the JavaScript code to be rendered into the page::
 #:
 #:     from waeup.sirp.browser.resources import datepicker
-#:     ...
-#:     class MyPage(...):
-#:       ...
+#:     # ...
+#:     class MyPage(...):
+#:       # ...
 #:       def update(self):
 #:         warning.need()
@@ -109,21 +112,23 @@
 #:   This way all required JavaScripts will be rendered correctly
 #:   into the HTML page generated.
-#: 
+#:
 #:   In your HTML code add some <input> or <a> tag with onClick event:
 #:
-#:   <input type="submit" name="xyz" value="abc"/>
-#:          onclick="return confirmPost('Are you sure?')">
+#:   .. code-block:: html
+#:
+#:        <input type="submit" name="xyz" value="abc"/>
+#:               onclick="return confirmPost('Are you sure?')">
 warning = ResourceInclusion(waeup_sirp, 'warning.js')
 
 #: If you have many select boxes in a from which have to be selected at the same
-# time you have to perform
-#: two steps:
-#: * In the `update()` method of the responsible view/page/form
-#:   require the JavaScript code to be rendered into the page:
+#: time you have to perform two steps:
+#:
+#: * In the `update()` method of the responsible view/page/form
+#:   require the JavaScript code to be rendered into the page::
 #:
 #:     from waeup.sirp.browser.resources import toggleall
-#:     ...
-#:     class MyPage(...):
-#:       ...
+#:     # ...
+#:     class MyPage(...):
+#:       # ...
 #:       def update(self):
 #:         toggleall.need()
@@ -134,6 +139,7 @@
 #:   In your HTML code add some <input> tag with onClick event:
 #:
-#:   <input type="checkbox" onClick="toggle(this, 'entries')" />
-
+#:   .. code-block:: html
+#:
+#:    <input type="checkbox" onClick="toggle(this, 'entries')" />
 toggleall = ResourceInclusion(waeup_sirp, 'toggleall.js')
 
@@ -141,15 +147,14 @@
 #: ``tabs``.
 #:
-#:
 #: If you want jQuery tabs for some <div>s in your page then you
 #: have to perform two steps:
 #:
 #: * In the `update()` method of the responsible view/page/form
-#:   require the JavaScript code to be rendered into the page:
+#:   require the JavaScript code to be rendered into the page::
 #:
 #:     from waeup.sirp.browser.resources import tabs
-#:     ...
-#:     class MyPage(...):
-#:       ...
+#:     # ...
+#:     class MyPage(...):
+#:       # ...
 #:       def update(self):
 #:         tabs.need()
@@ -159,6 +164,8 @@
 #:
 #: * In your HTML code add some ``<div>`` tag with ``class`` set to
-#    ``tabs``, like this::
-#:    
+#:   ``tabs``, like this:
+#:
+#:    .. code-block:: html
+#:
 #:      <div id="tabs">
 #:        <ul>
@@ -195,5 +202,5 @@
 #: A stylesheet for datatables
 datatables_css = ResourceInclusion(waeup_sirp, 'datatables.css')
-                                  
+
 #: A resource that turns HTML tables into sortable, searchable and :
 #: multi-page widgets using jQuery and the dataTables plugin available
@@ -204,10 +211,10 @@
 #:
 #: * In the `update()` method of the responsible view/page/form
-#:   require the JavaScript code to be rendered into the page:
+#:   require the JavaScript code to be rendered into the page::
 #:
 #:     from waeup.sirp.browser.resources import datatable
-#:     ...
-#:     class MyPage(...):
-#:       ...
+#:     # ...
+#:     class MyPage(...):
+#:       # ...
 #:       def update(self):
 #:         datatable.need()
@@ -217,5 +224,7 @@
 #:
 #: * Assign a ``display dataTable`` class to the HTML table you want to tune:
-#:    
+#:
+#:   .. code-block:: html
+#:
 #:      <table class="display dataTable">
 #:        <thead>
@@ -246,9 +255,9 @@
 #: Register basic YUI based CSS as a resource.
 reset_fonts_grids = ResourceInclusion(
-    waeup_sirp, 'yuirfg.css')    
-    
+    waeup_sirp, 'yuirfg.css')
+
 yuiapp_css = ResourceInclusion(
     waeup_sirp, 'yuiapp.css',
-    depends=[reset_fonts_grids])     
+    depends=[reset_fonts_grids])
 
 #: Register basic WAeUP base CSS (which is based on ``yuiapp.css`` as a
Index: main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/theming.py
===================================================================
--- main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/theming.py	(revision 7030)
+++ main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/browser/theming.py	(revision 7031)
@@ -88,10 +88,10 @@
     A named global utility implementing
 
-      :class:`zope.schema.interfaces.IVocabularyFactory
+      :class:`zope.schema.interfaces.IVocabularyFactory`
 
     and registered under the name
 
       'waeup.sirp.browser.theming.ThemesVocabulary'
-    
+
     Interface fields that wish to provide a list of available themes
     can require a 'named vocabulary', i.e. set:
@@ -107,5 +107,5 @@
     grok.implements(IVocabularyFactory)
     grok.name('waeup.sirp.browser.theming.ThemesVocabulary')
-    
+
     def __call__(self, context):
         """Deliver a vocabulary of available themes.
Index: main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/imagestorage.py
===================================================================
--- main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/imagestorage.py	(revision 7030)
+++ main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/imagestorage.py	(revision 7031)
@@ -457,5 +457,5 @@
 
     An ExtFileStore instance is available as a global utility
-    implementing :iface:`waeup.sirp.interfaces.IExtFileStore`.
+    implementing :class:`waeup.sirp.interfaces.IExtFileStore`.
 
     To add and retrieve files from the storage, use the appropriate
Index: main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/university/certificatecontainer.py
===================================================================
--- main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/university/certificatecontainer.py	(revision 7030)
+++ main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/university/certificatecontainer.py	(revision 7031)
@@ -26,5 +26,5 @@
 
     Each :class:`CertificateContainer` provides
-    :iface:`ICertificateContainer`.
+    :class:`ICertificateContainer`.
     """
     grok.implements(ICertificateContainer)
@@ -35,5 +35,5 @@
 
         The `certificate` must be an object implementing
-        :iface:`waeup.sirp.university.interfaces.ICertificate`. If
+        :class:`waeup.sirp.university.interfaces.ICertificate`. If
         not, a :exc:`TypeError` is raised.
 
@@ -75,5 +75,5 @@
 
         The certificate must be an object implementing
-        :iface:`waeup.sirp.university.interfaces.ICertificate`. If
+        :class:`waeup.sirp.university.interfaces.ICertificate`. If
         not, a :exc:`TypeError` is raised.
 