Index: /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/browser.py
===================================================================
--- /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/browser.py	(revision 7049)
+++ /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/browser.py	(revision 7050)
@@ -54,7 +54,4 @@
     ManageActionButton, PrimaryNavTab, LeftSidebarLink
     )
-from waeup.sirp.image.browser.widget import (
-    ThumbnailWidget, EncodingImageFileWidget,
-    )
 from waeup.sirp.image.image import createWAeUPImageFile
 from waeup.sirp.interfaces import (
@@ -67,6 +64,5 @@
 from waeup.sirp.widgets.objectwidget import (
     WAeUPObjectWidget, WAeUPObjectDisplayWidget)
-from waeup.sirp.applicants import (
-    ResultEntry, Applicant, get_applicant_data, get_regno_or_ac)
+from waeup.sirp.applicants import ResultEntry, Applicant, get_applicant_data
 from waeup.sirp.applicants.interfaces import (
     IApplicant, IApplicantPrincipal,IApplicantEdit, IApplicantsRoot,
@@ -730,6 +726,4 @@
             #storage = queryUtility(IExtFileStorage)
             # filename = '__img_appl__' + str(self.context.reg_no) #upload.filename
-            from waeup.sirp.interfaces import (
-                IExtFileStore, IFileStoreNameChooser)
             store = getUtility(IExtFileStore)
             file_id = IFileStoreNameChooser(self.context).chooseName()
Index: /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/tests/test_interfaces.py
===================================================================
--- /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/tests/test_interfaces.py	(revision 7049)
+++ /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/tests/test_interfaces.py	(revision 7050)
@@ -25,12 +25,7 @@
 import unittest
 from zc.sourcefactory.browser.source import FactoredTerms
-from zope.browser.interfaces import ITerms
-from zope.component import getMultiAdapter
-from zope.interface.verify import verifyClass, verifyObject
 from zope.publisher.browser import TestRequest
-from waeup.sirp.applicants import interfaces
-from waeup.sirp.applicants.vocabularies import (
-    APPLICATION_TYPES, application_types_vocab, GenderSource,
-    )
+from waeup.sirp.applicants.vocabularies import application_types_vocab
+from waeup.sirp.students.vocabularies import GenderSource
 
 class ApplicationCategoriesTestCase(unittest.TestCase):
Index: /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/vocabularies.py
===================================================================
--- /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/vocabularies.py	(revision 7049)
+++ /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/vocabularies.py	(revision 7050)
@@ -1,13 +1,8 @@
 """Vocabularies and sources for the application section.
 """
-from datetime import datetime
 from zope.component import getUtility
 from zope.catalog.interfaces import ICatalog
-from zc.sourcefactory.basic import BasicSourceFactory
-from zc.sourcefactory.contextual import BasicContextualSourceFactory
 from waeup.sirp.interfaces import SimpleWAeUPVocabulary
-from waeup.sirp.students.lgas import LGAS
-from waeup.sirp.students.vocabularies import (
-    CertificateSource, GenderSource)
+from waeup.sirp.students.vocabularies import CertificateSource
 
 #: Types of applications we support.
Index: /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/workflow.py
===================================================================
--- /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/workflow.py	(revision 7049)
+++ /main/waeup.sirp/branches/ulif-extimgstore/src/waeup/sirp/applicants/workflow.py	(revision 7050)
@@ -2,5 +2,4 @@
 """
 import grok
-from datetime import datetime
 from hurry.workflow.workflow import Transition, WorkflowState, NullCondition
 from hurry.workflow.interfaces import IWorkflowState, IWorkflowTransitionEvent